/*
  wasapi.hpp (2011-08-16)
  author: Fatbag
  
  ruby-specific header to (eventually) provide mingw-friendly wasapi interfaces
*/

#include <BaseTyps.h>

//MinGW32-w64 compatibility
#define _INC_PROPSYS
#define __in
#define __in_ecount(x)
#define __in_opt
#define __out
#define __out_ecount(x)
#define __out_opt
#define __deref_out
typedef interface IPropertyStore IPropertyStore;

//MinGW32 compatibility
#define BYTE_BLOB
typedef struct _tagpropertykey
{
    GUID fmtid;
    DWORD pid;
} PROPERTYKEY;
#define __propidl_h__
#define REFPROPVARIANT const PROPVARIANT &
#define DEFINE_ENUM_FLAG_OPERATORS(ENUMTYPE)
typedef long long REFERENCE_TIME;

#include <rpcsal.h>
#include <Mmdeviceapi.h>
#include <Audioclient.h>

#define DEFINE_CLSID(className, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
    const GUID CLSID_##className = {0x##l,0x##w1,0x##w2,{0x##b1,0x##b2,0x##b3,0x##b4,0x##b5,0x##b6,0x##b7,0x##b8}}

#define DEFINE_IID(interfaceName, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
    const GUID IID_##interfaceName = {0x##l,0x##w1,0x##w2,{0x##b1,0x##b2,0x##b3,0x##b4,0x##b5,0x##b6,0x##b7,0x##b8}}

DEFINE_CLSID(MMDeviceEnumerator, BCDE0395, E52F, 467C, 8E, 3D, C4, 57, 92, 91, 69, 2E);
DEFINE_IID(IMMDeviceEnumerator, A95664D2, 9614, 4F35, A7, 46, DE, 8D, B6, 36, 17, E6);
DEFINE_IID(IAudioClient, 1CB9AD4C, DBFA, 4C32, B1, 78, C2, F5, 68, A7, 03, B2);
DEFINE_IID(IAudioRenderClient, F294ACFC, 3146, 4483, A7, BF, AD, DC, A7, C2, 60, E2);